// listbox.cpp

#include "listbox.h"
#include "hardware.h"

//-------------------------------------------------------------------------------------

Listbox::Listbox() {
	nlines=0;
	curline=0;
	x=100;
	y=500; // tmp
	yinc=-19;
	size=10;
	for (int i=0; i<300; i++) lines[i][0]=0;
	//line.italic=0;
	line.set_color(1,.95,.9);
};

Listbox::~Listbox() {};

//--------------------------------------------------------------------

void Listbox::load(void) {
	char s[80];

	nscreenlines=16;//Hw::get()->screen.height/-yinc;
	y=.9*Hw::get()->screen.height;
	strcpy(s,"info.txt"); // build filename to open
	ifstream file(s,ios::nocreate);
	if (file.bad()||(file==0)) return;

	while ((!file.eof())&&(nlines<299)) {
		file.getline(&lines[nlines][0],110); // read line
		nlines++;
	}
}

//--------------------------------------------------------------------

void Listbox::update(void) {
	if (nlines) {
		if      (Hw::get()->key.arrow[2]==1) curline=clampi(curline+1,0,nlines-1);
		else if (Hw::get()->key.arrow[3]==1) curline=clampi(curline-1,0,nlines-1);
		if      (Hw::get()->key.skey==GLUT_KEY_PAGE_DOWN) curline=clampi(curline+10,0,nlines-1);
		else if (Hw::get()->key.skey==GLUT_KEY_PAGE_UP)   curline=clampi(curline-10,0,nlines-1);
	}
}

//--------------------------------------------------------------------

void Listbox::draw(void) {
	float y2=y;
	for (int i=curline; i<mini(curline+nscreenlines,nlines); i++) {
		line.print(&lines[i][0],x,y2,size);
		y2+=yinc;
	}
}

//--------------------------------------------------------------------

