#if !defined particle_h
#define      particle_h

#include "base.h"
#include "texture.h"

//---------------------------------------------------------------------------------

class Part:public Base{
public:		Part();
	virtual ~Part();

	int on;
	float sizex,sizey,sizez, size0,size1,size, r0,g0,b0, r1,g1,b1; //lastx,lasty,lastz, 
	float slickness, mass, lifeTime, birthTime, deathTime, age;
};

//---------------------------------------------------------------------------------
 
class Particle:public Base{
public:		Particle();
	virtual ~Particle();

	Texture *tex;
	Part p[1001];

	int   maxparticles, init, on;

	float lifeTime, lifeTimeRnd, interval, lastTime;
	float r0,g0,b0, r1,g1,b1, alpha0,alpha1, colorRnd;
	float size0,size1, size, sizex,sizey,sizez, sizeRnd;
	float windx,windy,windz, dispersex,dispersey,dispersez, length, rollspeed;
	float tx0, tx1, ty0, ty1;

	int  collision(float x, float y, float z, float distance);
	int  count(void);
	int  create(float x, float y, float z);
	void draw(void);
	void kill(void);
	void set(void);
	void unset(void);
	void update(void);
};

//---------------------------------------------------------------------------------------

#endif