#if !defined starfield_h
#define      starfield_h

#include "main.h"
#include "hardware.h"

//---------------------------------------------------------------------------------

class Starfield{
public:     Starfield();
	virtual ~Starfield();

	GLuint listID;
	int n, type, blend, depthtest, depthwrite, nlevel;
	float size, hollow, minc, maxc;
	Hw *hw;

	void destroy(void);
	void draw(void);
	void init(void);
};

//---------------------------------------------------------------------------------------

#define maxarray 1001

class Starfield2:public Base{
public:     Starfield2();
	virtual ~Starfield2();

	int n, type;
	float size, sizei, hollow, minc, maxc;
	float bound0,bound1;
	float xs[maxarray],ys[maxarray],zs[maxarray], rs[maxarray],gs[maxarray],bs[maxarray];
	float xis[maxarray],yis[maxarray],zis[maxarray];
	float intens[maxarray],intenis[maxarray];

	Texture *tex;
	Hw *hw;

	void draw(void);
	void init(void);
	void update(void);
	void brownian(void);
};

//---------------------------------------------------------------------------------------

#endif


