//
#include "billboard.h"
#include "hardware.h"

//------------------------------------------------------------------------
//------------------------------------------------------------------------
//------------------------------------------------------------------------

Billboard::Billboard(){
	sizex=1; 
	sizey=sizex;
};
Billboard::~Billboard(){};

//----------------------------------------------------------------------------

void Billboard::draw(float size){
	glPushMatrix();
		glTranslatef(0,sizey,0);
		glRotatef(Hw::get()->screen.viewport->camera.place.orient.y,0,1,0);
		glRotatef(Hw::get()->screen.viewport->camera.place.orient.x,1,0,0);
		glBegin(GL_QUADS);
			glTexCoord2f(0,0); glVertex2f(-sizex,-sizey);
			glTexCoord2f(1,0); glVertex2f( sizex,-sizey);
			glTexCoord2f(1,1); glVertex2f( sizex, sizey);
			glTexCoord2f(0,1); glVertex2f(-sizex, sizey);
			glEnd();
		glPopMatrix();
	Hw::get()->pref.ntris+=2;
}

//----------------------------------------------------------------------------

int Billboard::collide(Place *place, Physics *physicson){return 0;};

//----------------------------------------------------------------------------

void Billboard::init(void){};

//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------


