#if !defined physics_h
#define      physics_h

#include "vector.h"
#include "main.h"

//---------------------------------------------------------

class Place;

class Physics{
public: Physics();
	virtual ~Physics();

	Vector gravity, movedrag, rotatedrag, friction;
	float gravityScaler, dragScaler, spdLimit;

	void damp(Place *place);
	void apply_gravity(Place *place);
	int ltFriction(Vector *v);
	void bounce(Place* place1, Place *place2);
	void limit_spd(Place *place);
};

//--------------------------------------------------------

#endif

