#if !defined text_h
#define      text_h

#include <string.h>
#include "main.h"
#include "base.h"
#include "texture.h"

//-------------------------------------------------------------------------------------

class Text:public Base{
public:     Text();
	virtual ~Text();
	
	static int charInX,charInY;
	static float txoffy;
	int   autoset, bend, bloom;
	float xinc, yinc, size, italic, duration, endTime, inten;
	float  bendspeedx, bendspeedy, bendamplx, bendamply;
	float	 bloomspeedx,bloomspeedy,bloomamplx,bloomamply;

	char   s[200];
	static Texture *tex;

	void hold(char *ins);
	void hold(char *format, float value);
	void hold(char *format, int value);
	void hold(char *format, char *value);
	void hold_multi(int value,char *s0,char *s1=0,char *s2=0,char *s3=0,char *s4=0,char *s5=0,
		                       char *s6=0,char *s7=0,char *s8=0,char *s9=0,char *s10=0);
	void print(char *s);
	void print(char *s, float x, float y, float size);
	void print_hold(void);
	void reset(void);
	void set(void);
	void unset(void);
};
   
//-------------------------------------------------------------------------------------

class Scroller:public Text{
public:     Scroller();
	virtual ~Scroller();
	
	char abuff[101],sbuff[201];
	float scroll, scrolli;
	unsigned int buflen;

	int msg(const char *ins);
	void print(void);
	void reset(void);
};

//----------------------------------------------------------------------------------

#endif
